## Copyright © LIMSI-CNRS (2013)
##
## contributor(s) : Jorge Gascon, Damien Touraine, David Poirier-Quinot,
## Laurent Pointal, Julian Adenauer, 
## 
## This software is a computer program whose purpose is to distribute
## blender to render on CAVE(TM) device systems.
## 
## This software is governed by the CeCILL  license under French law and
## abiding by the rules of distribution of free software.  You can  use, 
## modify and/ or redistribute the software under the terms of the CeCILL
## license as circulated by CEA, CNRS and INRIA at the following URL
## "http://www.cecill.info". 
## 
## As a counterpart to the access to the source code and  rights to copy,
## modify and redistribute granted by the license, users are provided only
## with a limited warranty  and the software's author,  the holder of the
## economic rights,  and the successive licensors  have only  limited
## liability. 
## 
## In this respect, the user's attention is drawn to the risks associated
## with loading,  using,  modifying and/or developing or reproducing the
## software by the user in light of its specific status of free software,
## that may mean  that it is complicated to manipulate,  and  that  also
## therefore means  that it is reserved for developers  and  experienced
## professionals having in-depth computer knowledge. Users are therefore
## encouraged to load and test the software's suitability as regards their
## requirements in conditions enabling the security of their systems and/or 
## data to be ensured and,  more generally, to use and operate it in the 
## same conditions as regards security. 
## 
## The fact that you are presently reading this means that you have had
## knowledge of the CeCILL license and that you accept its terms.
## 

import select
import blender_cave.base

class Select(blender_cave.base.Base):
    
    def __init__(self, parent):
        super(Select, self).__init__(parent)
        self._select  = []
        self._clients = {}

    def setClient(self, client, method = None):
        if method is None:
            if client in self._select:
                self._select.remove(client)
            if client not in self._clients:
                del(self._clients[client])
        else:
            if client not in self._select:
                self._select.append(client)
            self._clients[client] = method

    def run(self, wait):
        if len(self._select) == 0:
            return

        if wait:
            inputready,outputready,exceptready = select.select(self._select, [], [])
        else:
            inputready,outputready,exceptready = select.select(self._select, [], [], 0)
        for peer in inputready:
            self._clients[peer](peer)
