import blender_cave
import bge
from bge import events as e

def getObjectUser(obj,user):
    osc_obj = blender_cave.getOSC().getObject(obj)
    osc_user = blender_cave.getOSC().getUser(user)
    osc_user_object = blender_cave.getOSC().getObjectUser(osc_obj, osc_user)
    return osc_user_object

def main(controller):
	OSC = blender_cave.getOSC()

	## Keyboard Controls
	k = bge.logic.keyboard.events
	upArrow = k[e.UPARROWKEY] == 1
	downArrow = k[e.DOWNARROWKEY] == 1
	space = k[e.SPACEKEY] == 1
	enter = k[e.ENTERKEY] == 1
	skey = k[e.SKEY] == 1
	wkey = k[e.WKEY] == 2
	rkey = k[e.RKEY] == 1
	qkey = k[e.QKEY] == 1
	shift = k[e.LEFTSHIFTKEY] == 2
	alt = k[e.LEFTALTKEY] == 2

	## Keyboard interactions
	if upArrow:
		vol = '+10'
		if not shift and not alt and not wkey: # global volume
			print('volume global',vol)
			OSC.getGlobal().volume(vol)
		if shift: # instrument (object) 0 volume only
			instrument = bge.logic.instrumentList[0]
			osc_instrument = OSC.getObject(instrument)
			print('volume instrument',vol)
			osc_instrument.volume(vol)
		if alt: # User1 volume only
			userBinaural1 = blender_cave.getUserByName('user B')
			userBinaural1.BlenderCave_OSC.volume(vol)
			print('volume User Binaural1',vol)
		if wkey:
			instrument = bge.logic.instrumentList[0]
			userBinaural1 = blender_cave.getUserByName('user B')
			osc_user_object = getObjectUser(instrument,userBinaural1)
			print('volume objectUser',vol)
			osc_user_object.volume(vol)


	if downArrow:
		vol = '-10'
		if not shift and not alt and not wkey: # global volume
			print('volume global',vol)
			OSC.getGlobal().volume(vol)
		if shift: # instrument (object) 0 volume only
			instrument = bge.logic.instrumentList[0]
			osc_instrument = OSC.getObject(instrument)
			print('volume instrument',vol)
			osc_instrument.volume(vol)
		if alt: # User1 volume only
			userBinaural1 = blender_cave.getUserByName('user B')
			userBinaural1.BlenderCave_OSC.volume(vol)
			print('volume User Binaural1',vol)
		if wkey:
			instrument = bge.logic.instrumentList[0]
			userBinaural1 = blender_cave.getUserByName('user B')
			osc_user_object = getObjectUser(instrument,userBinaural1)
			print('volume objectUser',vol)
			osc_user_object.volume(vol)


	if space:
		if bge.logic.counter<len(bge.logic.instrumentList):
			instrument = bge.logic.instrumentList[bge.logic.counter]
			osc_instrument = OSC.getObject(instrument)
			instrument.setVisible(True)
			osc_instrument.mute(False)
			osc_instrument.position(instrument.worldTransform)
			print(instrument,'unmuted, plays',bge.logic.soundList[bge.logic.counter],'-- at position:',[round(elmt, 2) for elmt in instrument.worldPosition[::]], '\n')
			if bge.logic.counter > 0:
				oldInstrument = bge.logic.instrumentList[bge.logic.counter-1]
				osc_oldInstrument = OSC.getObject(oldInstrument)
				oldInstrument.setVisible(False)
				osc_oldInstrument.mute(True)
				print(oldInstrument,'muted')
			bge.logic.counter += 1
		elif bge.logic.counter == len(bge.logic.instrumentList):
			print('$$$ Unmute all $$$')
			for instrument in bge.logic.instrumentList:
				osc_instrument = OSC.getObject(instrument)
				instrument.setVisible(True)
				osc_instrument.mute(False)

	if enter:
		print('toggle sound ',OSC.stateToggle)
		OSC.getGlobal().start(OSC.stateToggle)

	#if skey:
	#    config = bge.logic.configList[bge.logic.configCount]
	#    bge.logic.configCount = (bge.logic.configCount+1)%len(bge.logic.configList)
	#    print(bge.logic.configCount,len(bge.logic.configList))
	#    print('shifting to',config,'configuration...')
	#    OSC.getGlobal().configuration(config)

	if qkey:
		print('Synchronize sfplays')
		for i in range(0,len(bge.logic.instrumentList)):
			instrument = bge.logic.instrumentList[i]
			osc_instrument = OSC.getObject(instrument)
			osc_instrument.start(True)
			# Doesn't send max msg

	if rkey:
		OSC.getGlobal().reset()


