import blender_cave
import bge
import mathutils
import math
import random

def getMatRandom(scale):
	matWGN = mathutils.Matrix()
	matWGN[0][0] = scale*random.random()
	matWGN[1][0] = scale*random.random()
	matWGN[2][0] = scale*random.random()
	matWGN[3][0] = 0
	matWGN[0][1] = scale*random.random()
	matWGN[1][1] = scale*random.random()
	matWGN[2][1] = scale*random.random()
	matWGN[3][1] = 0
	matWGN[0][2] = scale*random.random()
	matWGN[1][2] = scale*random.random()
	matWGN[2][2] = scale*random.random()
	matWGN[3][2] = 0
	matWGN[0][3] = scale*random.random()
	matWGN[1][3] = scale*random.random()
	matWGN[2][3] = scale*random.random()
	matWGN[3][3] = 1
	return matWGN

def coordBlender2CAVE(mat_blender):
	mat1 = mathutils.Matrix.Rotation(math.radians(-90.0), 4, 'X')
	mat2 = mathutils.Matrix.Rotation(math.radians(-90.0), 4, 'Y')
	mat_CAVE = mat2*mat1*mat_blender
	return mat_CAVE

def main(controller):
	# Get Blender KX_GameObject (used later as a blener_cave user)
	try:
		objects = bge.logic.getCurrentScene().objects
		fakeUser = objects['Suzanne']

		# Get user coordinates
		fakeUser_worldTransform = fakeUser.worldTransform
		fakeUserMatHomo_worldTransformCAVE = coordBlender2CAVE(fakeUser_worldTransform)

		# Fake user jitter to force refresh in blender_cave
		# matWGN = getMatRandom(0.001) # scale variations
		# fakeUserMatHomo_worldTransformCAVE = fakeUserMatHomo_worldTransformCAVE + matWGN

		# refresh pos (if different from previous frame hardcoded in blender_cave)
		userCAVE1 = blender_cave.getUserByName('user A')
		userCAVE2 = blender_cave.getUserByName('user B')
		userCAVE1.setPosition(fakeUserMatHomo_worldTransformCAVE)
		# print(fakeUser1.worldPosition)
		# print(userCAVE2.getPosition())
	except KeyError as e:
		pass
