import blender_cave
import bge
import os
from inspect import getmembers, isfunction

def main(controller):
	os.system( [ 'clear', 'cls' ][ os.name == 'nt' ] ) # to clear terminal from anything else
	print("List BlenderCAVE OSC Methods for Global, Object, User and ObjectUser Classes:")
	print('\n'+"------------------------------------------------------------------")
	
	scene = bge.logic.getCurrentScene()
	instrument = scene.objects['Instrument']
	
	unwantedMethods = ['_','get','run']
	foundKey = False
	
	print('Global OSC methods:')
	osc_global = blender_cave.getOSC().getGlobal()
	
	print (bge.logic.globalMethods['info'])
	for method in dir(osc_global): 
		if not any(x in str(method) for x in unwantedMethods): 
			print (' - ' + method +'():')
			for key in bge.logic.globalMethods.keys():
				if str(method) in key:
					print ('\t'+bge.logic.globalMethods[key])
					foundKey = True
			if not foundKey: print ('\t'+'UNDEFINED')
			foundKey = False
	
	print('\n'+'Object OSC methods:')
	osc_object = blender_cave.getOSC().getObject(instrument)

	print (bge.logic.objectMethods['info'])
	for method in dir(osc_object): 
		if not any(x in str(method) for x in unwantedMethods): 
			print (' - ' + method +'():')
			for key in bge.logic.objectMethods.keys():
				if str(method) in key:
					print ('\t'+bge.logic.objectMethods[key])
					foundKey = True
			if not foundKey: print ('\t'+'NOT DEFINED')
			foundKey = False

	
	print('\n'+'User OSC methods:')
	osc_user = blender_cave.getOSC().getUser('Binaural 1')

	print (bge.logic.userMethods['info'])
	for method in dir(osc_user): 
		if not any(x in str(method) for x in unwantedMethods): 
			print (' - ' + method +'():')
			for key in bge.logic.userMethods.keys():
				if str(method) in key:
					print ('\t'+bge.logic.userMethods[key])
					foundKey = True
			if not foundKey: print ('\t'+'NOT DEFINED')
			foundKey = False
				
	print('\n'+'ObjectUser OSC methods:')
	osc_object_user = blender_cave.getOSC().getObjectUser(osc_object, osc_user)
	print (bge.logic.objectUserMethods['info'])
	for method in dir(osc_object_user): 
		if not any(x in str(method) for x in unwantedMethods): 
			print (' - ' + method +'():')
			for key in bge.logic.objectUserMethods.keys():
				if str(method) in key:
					print ('\t'+bge.logic.objectUserMethods[key])
					foundKey = True
			if not foundKey: print ('\t'+'NOT DEFINED')
			foundKey = False
	
	print('\n','----------------------------------------','\n', "### Closing BlenderCave_OSC_API",'\n',"### look above for OSC API listing",'\n',"### (this is not a scene to be admired)", '\n','----------------------------------------','\n')
	print("------------------------------------------------------------------"+'\n')