import bge

def main(controller):

	bge.logic.globalMethods = {
	
	"info":
	"""## Global OSC methods for sync. with OSC Sound Rendering Engine

global_OSC = blender_cave.getOSC().getGlobal()""" ,
	
	"configuration":
	"""Set the OSC client configuration (e.g. "ambisonic EVE")
	use: global_OSC.configuration(<string>) 
	OSC flag: /global configuration 'ambisonic EVE'""",
	
	"mute":
	"""Mute/Unmute global audio
	use: global_OSC.mute(<bool>)
	OSC flag: /global mute <1/0>""",
	
	"reset":
	"""Reset OSC client (used automatically when calling blender_cave.quit())
	use: global_OSC.reset()
	OSC flag: /global reset""",

	"start":
	"""Start/Stop gloabal Audio
	use: global_OSC.start(<bool>)
	OSC flag: /global start <1/0>""",
	
	"volume":
	"""Set global Volume
	use: global_OSC.volume(<string>)
	OSC flag: /global volume +<int> / -<int> (relative)
		     or /global volume %<int>  (absolute)""",
	}

	bge.logic.objectMethods = {

	"info":
	"""## Object OSC methods for sync. with OSC Sound Rendering Engine

object_OSC = blender_cave.getOSC().getObject(<bge.types.KX_Gameobject>)""" ,
	
	"loop":
	"""Set loop on Object sound
	use: object_OSC.loop(<bool>)
	OSC flag: /object <ID> loop <1/0>""",
	
	"mute":
	"""Mute/Unmute Object audio
	use: object_OSC.mute(<bool>)
	OSC flag: /object <ID> mute <1/0>""",
	
	"position":
	"""set OSC Object position
	use: object_OSC.position(<Mat4x4>)
	OSC flag: /object <ID> position <float> (x16)""",

	"sound":
	"""Set Object sound
	use: object_OSC.sound(<str>)
	OSC flag: /object <ID> sound <str>""",
	
	"start":
	"""Set Object volume
	use: object_OSC.start(<bool>)
	OSC flag: flag: /object <ID> start <1/0>""",

	"volume":
	"""Set Object Volume
	use: object_OSC.volume(<string>)
	OSC flag: flag: /object <ID> volume +<int> / -<int> (relative)
		     or /object volume <ID> %<int>  (absolute)""",		     
	}
	
	bge.logic.userMethods = {

	"info":
	"""## User OSC methods for sync. with OSC Sound Rendering Engine

user_OSC = blender_cave.getOSC().getUser(<string>) where <string> is the user (listener) name defined in you .xml file.""",
	
	"mute":
	"""Mute/Unmute User audio
	use: user_OSC.mute(<bool>)
	OSC flag: /user <ID> mute <1/0>""",
	
	"position":
	"""???set/get OSC User position
	use: user_OSC.position(<Mat4x4>)
	OSC flag: /user <ID> position <float> (x16)""",
	
	"start":
	"""Set User volume
	use: user_OSC.start(<bool>)
	OSC flag: flag: /user <ID> start <1/0>""",

	"volume":
	"""Set User Volume
	use: user_OSC.volume(<string>)
	OSC flag: flag: /user <ID> volume +<int> / -<int> (relative)
		     or /user volume <ID> %<int>  (absolute)""",		     
	}

	bge.logic.objectUserMethods = {

	"info":
	"""## ObjectUser OSC methods for sync. with OSC Sound Rendering Engine

object_user_OSC = blender_cave.""",
	
	"mute":
	"""Mute/Unmute User audio
	use: user_OSC.mute(<bool>)
	OSC flag: /user <ID> mute <1/0>""",

	"volume":
	"""Set User Volume
	use: user_OSC.volume(<string>)
	OSC flag: flag: /user <ID> volume +<int> / -<int> (relative)
		     or /user volume <ID> %<int>  (absolute)""",		     
	}

# User
# 
# Set user HRTF:
# user.BlenderCave_OSC.hrtf(<int>)
# 		flag: /user ID hrtf <int>
# 
# Set user room parameters:
# user.BlenderCave_OSC.reverb_volume(<int>)
# 		flag: /user ID reverb_volume <int>
# (Also works with presence, warmth, etc.. see dir(user.BlenderCave_OSC) for an exhaustive list).
# 